<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            #{troSender.initializePage()}
            <s:decorate template="/hl7Initiators/orderSenderTemplate.xhtml">
                <ui:param name="managedBean" value="#{troSender}"/>
                <ui:param name="hl7Protocol" value="HTTP"/>
                <ui:param name="displaySequenceDiagram" value="#{messages['net.ihe.gazelle.False']}"/>
                <ui:define name="sutConfiguration">
                    <s:div id="sutConfiguration">
                        <h:panelGrid columns="5">
                            <s:decorate template="/layout/edit.xhtml">
                                <ui:define name="label">#{messages['gazelle.ordermanager.TROForwarder']}</ui:define>
                                <h:selectOneMenu value="#{troSender.forwarder}" required="true" immediate="true">
                                    <s:selectItems value="#{troSender.getAvailableForwarders()}" var="sys"
                                                   label="#{sys.name}" noSelectionLabel="#{messages['gazelle.ordermanager.PleaseSelect']}"/>
                                    <a4j:ajax event="change" render="sutConfiguration"/>
                                </h:selectOneMenu>
                            </s:decorate>
                            <gdk:spacer width="20px"/>
                            <h:panelGroup>
                                <s:decorate template="/layout/edit.xhtml" rendered="#{troSender.isFowarderLocal()}">
                                    <ui:define name="label">
                                        <h:outputText value="#{messages['gazelle.ordermanager.TROCreator']}"
                                                      rendered="#{troSender.sutActorKeyword.equals('TRO_CREATOR')}"/>
                                        <h:outputText value="#{messages['gazelle.ordermanager.TROFulfiller']}"
                                                      rendered="#{troSender.sutActorKeyword.equals('TRO_FULFILLER')}"/>
                                    </ui:define>
                                    <h:selectOneMenu value="#{userPreferencesManagerBean.selectedSUT}" required="true">
                                        <s:selectItems
                                                value="#{hl7v2ResponderSUTConfiguration.getAllConfigurationsForSelection(troSender.sutActorKeyword, 'HTTP')}"
                                                var="sys" label="#{sys.name}" noSelectionLabel="#{messages['gazelle.ordermanager.PleaseSelect']}"/>
                                        <a4j:ajax event="change" render="sutConfiguration"/>
                                    </h:selectOneMenu>
                                </s:decorate>
                                <s:decorate template="/layout/edit.xhtml" rendered="#{not troSender.isFowarderLocal()}">
                                    <ui:define name="label">#{troSender.sutActorKeyword} #{messages['gazelle.hl7.URL']}</ui:define>
                                    <h:inputText value="#{troSender.sutApplication}">
                                        <a4j:ajax event="blur" render="sutConfiguration"/>
                                    </h:inputText>
                                </s:decorate>
                                <s:decorate template="/layout/edit.xhtml" rendered="#{not troSender.isFowarderLocal()}">
                                    <ui:define name="label">#{troSender.sutActorKeyword} #{messages['gazelle.hl7.ReceivingFacility']}</ui:define>
                                    <h:inputText value="#{troSender.sutFacility}">
                                        <a4j:ajax event="blur" render="sutConfiguration"/>
                                    </h:inputText>
                                </s:decorate>
                            </h:panelGroup>
                        </h:panelGrid>
                        <h:panelGrid columns="10">
                            <gri:panel>
                                <dl class="dl-horizontal">
                                    <f:facet name="header">#{troSender.simulatedActor.name}</f:facet>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.SendingApplication']}</ui:define>
                                        <h:outputText value="#{troSender.sendingApplication}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.SendingFacility']}</ui:define>
                                        <h:outputText value="#{troSender.sendingFacility}"/>
                                    </s:decorate>
                                </dl>
                            </gri:panel>
                            <h:graphicImage library="img" name="diag/#{troSender.simulatedActor.keyword}_send.png"/>
                            <h:panelGroup>
                                <gri:panel>
                                    <f:facet name="header">#{messages['gazelle.ordermanager.TROForwarder']}</f:facet>
                                    <dl class="dl-horizontal">
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.HL7Common.Name']}</ui:define>
                                            <h:outputText value="#{troSender.forwarder.name}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.hl7.URL']}</ui:define>
                                            <h:outputText value="#{troSender.forwarder.url}"/>
                                        </s:decorate>
                                    </dl>
                                </gri:panel>
                                <br/>
                                <gri:panel rendered="#{troSender.isFowarderLocal()}">
                                    <f:facet name="header">#{troSender.sutActorKeyword}</f:facet>
                                    <dl class="dl-horizontal">
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.HL7Common.Name']}</ui:define>
                                            <h:outputText value="#{userPreferencesManagerBean.selectedSUT.name}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.hl7.ReceivingApplication']}</ui:define>
                                            <h:outputText
                                                    value="#{userPreferencesManagerBean.selectedSUT.application}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.hl7.ReceivingFacility']}</ui:define>
                                            <h:outputText value="#{userPreferencesManagerBean.selectedSUT.facility}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.hl7.URL']}</ui:define>
                                            <h:outputText value="#{userPreferencesManagerBean.selectedSUT.url}"/>
                                        </s:decorate>
                                    </dl>
                                </gri:panel>
                                <gri:panel rendered="#{not troSender.isFowarderLocal()}">
                                    <f:facet name="header">#{troSender.sutActorKeyword}</f:facet>
                                    <dl class="dl-horizontal">
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.hl7.ReceivingApplication']}</ui:define>
                                            <h:outputText value="#{troSender.sutApplication}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['gazelle.hl7.ReceivingFacility']}</ui:define>
                                            <h:outputText value="#{troSender.sutFacility}"/>
                                        </s:decorate>
                                    </dl>
                                </gri:panel>
                            </h:panelGroup>
                        </h:panelGrid>
                    </s:div>
                </ui:define><!-- ordersDataTable -->
                <ui:define name="ordersDataTable">
                    <rich:dataTable value="#{troSender.orders}" var="orderVar"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="orders1Table"
                                    render="ds">
                        <ui:include src="/tro/orderColumns.xhtml">
                            <ui:param name="currentOrder" value="#{orderVar}"/>
                        </ui:include>
                        <g:column>
                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                            <a4j:commandLink value="#{messages['gazelle.ordermanager.Select']}"
                                             actionListener="#{troSender.setSelectedOrder(orderVar)}"

                                             oncomplete="#{rich:component('cancelDiscontinueOrderPanel')}.show();"
                                             rendered="#{troSender.orderControlCode.equals(troSender.cancel)             or troSender.orderControlCode.equals(troSender.discontinue)}"
                                             render="cancelDiscontinueOrderPanel"/>
                            <a4j:commandLink value="#{messages['gazelle.ordermanager.Select']}"
                                             actionListener="#{troSender.setSelectedOrder(orderVar)}"

                                             oncomplete="#{rich:component('updateOrderStatusPanel')}.show();"
                                             rendered="#{troSender.orderControlCode.equals(troSender.update)}"
                                             render="updateOrderStatusPanel"/>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="orders1Table"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </ui:define><!-- newObjectPart -->
                <ui:define name="newObjectPart">
                    <gri:panel rendered="#{troSender.selectedOrder != null}" pid="editOrderPanel">
                        <f:facet name="header">#{messages['gazelle.ordermanager.TheOrder']}</f:facet>
                        <a4j:commandButton styleClass="gzl-btn-blue"
                                           value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                           actionListener="#{troSender.fillOrderRandomly()}"
                                           immediate="true"
                                           render="editOrderPanel"/>
                        <br/><br/>
                        <ui:include src="/tro/fillingTRO.xhtml">
                            <ui:param name="order" value="#{troSender.selectedOrder}"/>
                        </ui:include>
                        <s:decorate template="/layout/edit.xhtml" id="studies">
                            <ui:define name="label">#{messages['gazelle.ordermanager.RelatedStudies']}</ui:define>
                            <h:panelGroup>
                                <a4j:repeat value="#{troSender.selectedOrder.relatedStudies}" var="study">
                                    <h:panelGrid columns="3">
                                        <rich:inplaceInput value="#{study}" showControls="true"/>
                                        <gdk:spacer width="5px"/>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.RemoveFromList']}" render="studies"
                                                         actionListener="#{troSender.removeAccessionNumber(study)}">
                                            <s:span styleClass="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                    </h:panelGrid>
                                </a4j:repeat>
                                <rich:inplaceInput value="#{troSender.currentAccessionNumber}"
                                                   defaultLabel="Accession Number of related study" showControls="true">
                                    <a4j:ajax event="change" render="studies"
                                              listener="#{troSender.addAccessionNumber()}"/>
                                </rich:inplaceInput>
                            </h:panelGroup>
                        </s:decorate>
                        <a4j:commandButton styleClass="gzl-btn-blue"
                                           value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                           actionListener="#{troSender.fillOrderRandomly()}"

                                           immediate="true"
                                           render="editOrderPanel"/>
                        <br/><br/>
                        <hr lineType="double" height="4"/>
                        <br/>
                        <s:div id="imagingProcedures"><h3>#{messages['gazelle.ordermanager.ImagingProcedures']}</h3>
                            <a4j:commandButton value="#{messages['gazelle.ordermanager.NewImagingProcedure']}"
                                               actionListener="#{troSender.createNewProcedure()}"
                                               rendered="#{empty troSender.currentProcedure}"
                                               render="imagingProcedures"/>
                            <br/><br/>
                            <gri:panel pid="imagingProcedureDef" rendered="#{not empty troSender.currentProcedure}">
                                <ui:include src="/tro/fillingImagingProcedure.xhtml">
                                    <ui:param name="ipc" value="#{troSender.currentProcedure}"/>
                                </ui:include>
                                <a4j:commandButton value="#{messages['gazelle.ordermanager.AddThisImagingProcedure']}"
                                                   actionListener="#{troSender.addProcedureToList()}"
                                                   render="imagingProcedures"/>
                            </gri:panel>
                            <rich:dataTable value="#{troSender.selectedOrder.teleRadiologyProcedures}" var="ipc"
                                            rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                                <ui:include src="/tro/teleRadiologyProcedureColumns.xhtml">
                                    <ui:param name="ipc" value="#{ipc}"/>
                                </ui:include>
                            </rich:dataTable>
                        </s:div>
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.SendMessage']}"
                                           actionListener="#{troSender.sendMessage()}"


                                           render="editOrderPanel, messages, globalDiv"/>
                    </gri:panel>
                </ui:define>
            </s:decorate>
        </h:form>
    </ui:define>
</ui:composition>
